function ApiContentConnector(){
    if(arguments.callee._singletonInstance){
	    return arguments.callee._singletonInstance;
	}
	arguments.callee._singletonInstance = this;

	var self = this; self.name = "ApiContentConnector"; // MANDATORY
  
    this.info = {};

    // API_DURATION Gets {command:this.API_DURATION,params:{duration:15}}
    this.API_DURATION = 0;
    // API_FINISH Gets {command:this.API_FINISH}
    this.API_FINISH = 1; // Is it really useful ?
    // API_CONDITION Gets {command:this.API_CONDITION,params:{'id': 0,'filename':"lat.xml",'value':24.123}}
    this.API_CONDITION = 2;
    // API_WRITE_FILE Gets {command:this.API_WRITE_FILE,params:{'path': "./",'filename':"test.txt",'text':"hello world!"}}
    this.API_WRITE_FILE = 3;
    // API_TOUCH Gets {command:this.API_TOUCH,params:{'id': 0,'filename':"lat.xml",'value':24.123}}
    this.API_ANALYTIC = 4;
    // API_PLAY : TO-DO
    this.API_PLAY = 5;
    // API_MAIN_DURATION : TO-DO
    this.API_MAIN_DURATION = 6;
    // API_READ_FILE Gets {command:this.API_READ_FILE,params:{'path': "./",'filename':"test.txt",callback:"callback_name"}}
    this.API_READ_FILE = 7;
    // API_PLAYER_INFO Gets {command:this.API_PLAYER_INFO}
    this.API_PLAYER_INFO = 8;

    this.execute = [];

    this.origin = "player.admira.com";
    
    this.origin_app = "";

    this.registered = [];
    
    this.updateInfo = function(name,data){
      self.info[name] = null;
      self.info[name] = data;
    };

    this.onEventAction = function(target,message,client,origin){
        var loaded = false;

        if(typeof(target.loaded) !== "undefined"){loaded = target.loaded;}

        if(message.action == "api_command" && loaded){
            self.sendApiContentEvent(client,'api_command',origin,"ok");
            self.execute[message.api.command](message.api,client,origin);
        }else{
            target.log("Event not execute because action : "+message.action+" and loaded : "+loaded);
        }
    };

    this.onMessage = function(e,client,origin,target){
        
        
        var message = false;
        try{
            message = JSON.parse(client.data);
        }catch(e){
            target.log("ApiContentEvent : Not valid Message");
        }
        if(message){
            if(message.destination == self.origin){
                if(message.action == "request_token"){
                    if(self.registered.indexOf(origin) == -1){
                        if(self.origin_app != client.origin){
                          self.origin_app = client.origin;
                        }
                        self.registered.push(origin);
                        self.sendApiContentEvent(client,'new_token',origin,"ok");
                    }
                }else{
                    self.onEventAction(target,message,client,origin);
                }
            }
        }
    };

    $(window).on("ApiContentEvent",this.onMessage);

    $(window).on("ApiContentUnregister",function(e,origin){
        var index = self.registered.indexOf(origin);
        if(index >= 0){
            self.registered.splice(index,1);
        }
    });

    this.sendApiContentEvent = function(client,action,destination,msg){
        var message = {
            destination: destination,
            action: action,
            msg: msg
        };
        client.source.postMessage(JSON.stringify(message),client.origin);
    };
  
    this.broadcastApiContentEvent = function(action,data){
      var message = null;
      for(var i in self.registered){
        message = {
            destination: self.registered[i],
            action: action,
            msg: data
        };
        if(self.origin_app != ""){
            //self.log(JSON.stringify(message))
          $("#"+self.registered[i])[0].contentWindow.postMessage(JSON.stringify(message),self.origin_app);
        }
        message = null;
      }
    };

    this.execute[this.API_DURATION] = function(command,target){
        $(self).trigger("ApiContentChangeDuration",[command]);
    };

    this.execute[this.API_FINISH] = function(command,target){
        $(self).trigger("ApiContentFinish",[command]);
    };

    this.execute[this.API_CONDITION] = function(command){
        $(self).trigger("ApiContentConditionSet",[command]);
    };

    this.execute[this.API_WRITE_FILE] = function(command){
        $(self).trigger("ApiContentWriteFile",[command]);
    };

    this.execute[this.API_READ_FILE] = function(command,client,origin){
        $(self).trigger("ApiContentReadFile",[command,client,origin]);
    };

    this.execute[this.API_ANALYTIC] = function(command){
        $(self).trigger("ApiContentAnalytic",[command]);
    };

    this.execute[this.API_PLAY] = function(command){
        $(self).trigger("ApiContentPlay",[command]);
    };

    this.execute[this.API_MAIN_DURATION] = function(command){
        $(self).trigger("ApiContentMainDuration",[command]);
    };
    
    this.execute[this.API_PLAYER_INFO] = function(command,client,origin){
        $(self).trigger("ApiContentGetPlayerInfo",[command,client,origin]);
    };
}
