function SocketConnector(OSs){
  if(arguments.callee._singletonInstance){
    return arguments.callee._singletonInstance;
  }
  arguments.callee._singletonInstance = this;
  var self = this; self.name = "SocketConnector"; // MANDATORY

  this.socketControl = null;
  this.connectSocket = false;
  this.version = "sck1.0.4";
  this.namePlayer = null;
  this.OS = OSs;


  this.initSocket = function(){
    if(self.socketControl === null && self.connectSocket === false){
      self.socketControl = io.connect("http://socket.control.admira.com:3003/"+self.OS.platform, {"transports": ['websocket'], "force new connection":false, "timeout":20000, "reconnection": true, "reconnectionDelay": 20000, "reconnectionDelayMax" : 25000, "reconnectionAttempts" :20});
      self.socketControl.on('connect', function(){
        self.socketControl.emit('room.join', {room: self.OS.core_id});
        self.namePlayer = self.OS.core_id;
      });
      self.socketControl.on('room.join.response', function(data){
        self.connectSocket = true;
        self.logsSocket("SocketConnector", data);
      });
      /*self.socketControl.on('disconnect', function(){
        self.socketControl.destroy();
        delete self.socketControl;
        self.socketControl = null;
        self.connectSocket = false;
      })*/
      self.socketControl.on('reboot', function(data){
        self.responseSocket("------------------------------------------------reboot");
        self.logsSocket("SocketConnector", "------------------------------------------------reboot");
        setTimeout(function(){self.OS.rebootSystem();},5000);
      });
      self.socketControl.on('getLic', function(data){
        self.responseSocket("------------------------------------------------getLic");
        self.OS.getLIC(function(result){
          self.responseSocket(result);
        })
      });
      self.socketControl.on("createLIC", function(data){
          self.responseSocket("------------------------------------------------createLIC");
          self.OS.createLIC(data, function(result){
            self.responseSocket(result);
          })
      });
      self.socketControl.on('deleteAll', function(data){
        self.responseSocket("------------------------------------------------deleteAll");
        self.OS.deleteAll(function(result){
          self.responseSocket(result);
        })
      });
      self.socketControl.on('deleteAllAll', function(data){
        self.responseSocket("------------------------------------------------deleteAllAll");
        self.OS.deleteAllAll(function(result){
          self.responseSocket(result);
        });
      });
      self.socketControl.on('getInfo', function(data){
        self.responseSocket("------------------------------------------------getInfo");
        self.OS.getInfoSystem(function(result){
          self.responseSocket(result);
        });
      });
      self.socketControl.on('getInfoPlus', function(data){
        self.responseSocket("------------------------------------------------getInfoSystemPlus");
        self.OS.getInfoSystemPlus(function(result){
          self.responseSocket(result);
        });
      });
      /*main_webos.socketControl.on('getPowerOnOffHistory', function(data){
          main_webos.logsSocket("socketControl", "------------------------------------------------getPowerOnOffHistory: ");
          transfer.OS.getPowerOnOffHistory(function(err, result){
              if(err){
                  main_webos.logsSocket("socketControl", JSON.stringify(err));
              }
              else{
                  main_webos.logsSocket("socketControl", JSON.stringify(result));
              }
          });
      });*/
      self.socketControl.on('getTimers', function(data){
        self.responseSocket("------------------------------------------------getTimers");
        self.OS.getTimers(function(result){
          self.responseSocket(JSON.stringify(result));
        });
      });

      self.socketControl.on('forceAlive', function(data){
          self.responseSocket("------------------------------------------------forceAlive");
          var data = self.OS.getAliveData();
          self.OS.api_connector.post(self.OS.api_url,self.OS.api_ver,"player/alive",data,self.OS.aliveResponse);

      });

      self.socketControl.on("getScreenshot", function(data){
          self.responseSocket("------------------------------------------------getScreenshot");
          self.OS.getScreenshot(function(result){
            self.responseSocket(result);
          });
      });
      self.socketControl.on('getStatusPanel', function(data){
          self.responseSocket("------------------------------------------------getStatusPanel: ");
          self.OS.getStatusPanel(function(err, result){
            self.responseSocket(result);
          });
      });
      self.socketControl.on('setPanelOff', function(data){
          self.responseSocket("------------------------------------------------setPanelOff: ");
          self.OS.setPanelOff(function(err, result){
            self.responseSocket(result);
          });
      });
      self.socketControl.on('setPanelOn', function(data){
          self.responseSocket("------------------------------------------------setPanelOn: ");
          self.OS.setPanelOn(function(err, result){
            self.responseSocket(result);
          });
      });
      self.socketControl.on("updateFirmware", function(data){
        self.responseSocket("------------------------------------------------updateFirmware");
        self.OS.updateFirmware(data, function(result){
          self.responseSocket(result);
        })
      })
      /* usados en webos */
      self.socketControl.on('clearCache', function(data){
          self.responseSocket("------------------------------------------------clearCache: ");
          self.OS.clearCache(function(result){
            self.responseSocket(result);
          });
      });
      self.socketControl.on('calculateReboot', function(data){
          self.responseSocket("------------------------------------------------calculateReboot: ");
          self.OS.calculateReboot(function(result){
            self.responseSocket(result);
          });
      });



      self.socketControl.on('upgradeApplication', function(data){
          self.responseSocket("------------------------------------------------upgradeApplication: ");
          self.OS.upgradeApplication(function(result){
            self.responseSocket(result);
          });
      });
      self.socketControl.on('upgradeApplicationInstall', function(data){
          self.responseSocket("------------------------------------------------upgradeApplicationInstall: ");
          self.OS.upgradeApplicationInstall(function(result){
            self.responseSocket(result);
          });
      });
      self.socketControl.on('upgradeApplicationInsert', function(data){
          self.responseSocket("------------------------------------------------upgradeApplicationInsert: ");
          self.OS.upgradeApplicationInsert(data.url, function(result){
            self.responseSocket(result);
          });
      });
      self.socketControl.on('upgradeApplicationNow', function(data){
          self.responseSocket("------------------------------------------------upgradeApplicationInstall: ");
          self.OS.upgradeApplicationNow(function(result){
            self.responseSocket(result);
          });
      });
      self.socketControl.on('updateApplicationS', function(data){
          self.responseSocket("------------------------------------------------updateApplicationS: ");
          self.OS.updateApplicationS(data.data, function(result){
            self.responseSocket(result);
          });
      });
      self.socketControl.on('changePictureMode', function(data){
          self.responseSocket("------------------------------------------------changePictureMode: ");
          self.OS.changePictureMode(data.mode, function(result){
            self.responseSocket(result);
          });
      });
      self.socketControl.on('getPictureProperty', function(data){
          self.responseSocket("------------------------------------------------getPictureProperty: ");
          self.OS.getPictureProperty(function(result){
            self.responseSocket(result);
          });
      });
     /* self.socketControl.on('setURLLauncher', function(data){
          self.responseSocket("------------------------------------------------setURLLauncher: ");
          self.OS.setURLLauncher(data.data, function(result){
            self.responseSocket(result);
          });
      });
      */
      self.socketControl.on('setPortraitMode', function(data){
          self.responseSocket("------------------------------------------------setPortraitMode: "+ data.mode);
          var se=Custom.NATIVEPORTRAIT.DEGREE_90;
          if(data.mode == "off"){
            se = Custom.NATIVEPORTRAIT.OFF;
          }
          else{
            if(data.mode == "180"){
              se = Custom.NATIVEPORTRAIT.DEGREE_180;  
            }
            else{
              if(data.mode == "270"){
                se = Custom.NATIVEPORTRAIT.DEGREE_270;  
              }
              else{
                se = Custom.NATIVEPORTRAIT.DEGREE_90;    
              }
            }
          }
          
//          self.OS.setMode(data, function(result){
          self.OS.setNativePortraitMode(se, function(result){
            self.responseSocket(result);
          })
      });
      self.socketControl.on('getContentRotation', function(data){
          self.responseSocket("------------------------------------------------getContentRotation: ");
          /*self.OS.getContentRotation(function(err, result){
              if(err){
                  self.responseSocket(JSON.stringify(err));
              }
              else{
                  self.responseSocket(result);
              }
          });*/
          self.OS.getNativePortraitMode(function(result){
            self.responseSocket(result);
          })
      });
      self.socketControl.on('setContentRotation', function(data){
          self.responseSocket("------------------------------------------------setContentRotation: "+ data.degree + " .. "+ data.aspectRatio);
          transfer.OS.setContentRotation({degree : data.degree, aspectRatio : data.aspectRatio}, function(err, result){
              if(err){
                  self.responseSocket(JSON.stringify(err));
              }
              else{
                  self.responseSocket(result);
              }
          });
      });
      self.socketControl.on('getVideoStatus', function(data){
          self.responseSocket("------------------------------------------------getVideoStatus: ");
          self.OS.getVideoStatus(function(err, result){
              if(err){
                  self.responseSocket(JSON.stringify(err));
              }
              else{
                  self.responseSocket(result);
              }
          });
      });
      self.socketControl.on('setFailoverMode', function(data){
          self.responseSocket("------------------------------------------------setFailoverMode: ");
          self.OS.setFailoverMode(data.mode, data.priority, function(result){
            self.responseSocket(result);
          });
      });
      self.socketControl.on('getFailoverMode', function(data){
          self.responseSocket("------------------------------------------------getFailoverMode: ");
          self.OS.getFailoverMode(function(result){
            self.responseSocket(result);
          });
      });
      self.socketControl.on('hdmiControlMode', function(data){
          self.responseSocket("------------------------------------------------hdmiControlMode: ");
          var displayHDMI = $('<div id="HDMIScreen" style="position:absolute;left:0px;top:0px;z-index:103;width:100%;"></div>');
          $("body").append(displayHDMI);
          self.OS.HDMIscreen(function(result){
            self.responseSocket(result);
          });
      });
      /* usados en soc */
      self.socketControl.on("copyUSB", function(data){
          self.responseSocket("------------------------------------------------copyUSB");
          self.OS.copyUSB(function(result){
            self.responseSocket(result);
          });
      })
      self.socketControl.on("deleteAndCopyUSB", function(data){
          self.responseSocket("------------------------------------------------deleteAndCopyUSB");
          self.OS.deleteAll2(function(result){
            self.responseSocket(result);
          });
      })
      self.socketControl.on('getFiles', function(data){
        self.responseSocket("-------------------------------------------getFiles");
        transfer.OS.listFilesDirectory(data.dir, function(result){
          self.responseSocket(result);
        });
      });
      /* use android */
      self.socketControl.on('exitKioskMode', function(data){
        self.responseSocket("-------------------------------------------exitKioskMode");
        transfer.OS.exitKioskMode(function(result){
          self.responseSocket(result);
        });
      })
      self.socketControl.on('getStatusKioskMode', function(data){
        self.responseSocket("-------------------------------------------getStatusKioskMode");
        transfer.OS.getStatusKioskMode(function(result){
          self.responseSocket(result);
        });
      })
      self.socketControl.on('getPowerOnOffHistory', function(data){
        self.responseSocket("------------------------------------------------getPowerOnOffHistory");
        self.OS.getPowerOnOffHistory(function(result){
          self.responseSocket(result);
        });
      });
    }
  };
  this.logsSocket = function(type, data){
    if(self.connectSocket === true){
      self.socketControl.emit('logs', {namePlayer: self.namePlayer, version: self.version, type: type, data: data});
    }
  };
  this.responseSocket = function(type, data){
    if(self.connectSocket === true){
      self.socketControl.emit('response', {namePlayer: self.namePlayer, version: self.version, type: type, data: data});
    }
  };
  this.disconnectSocket = function(){
    if (self.socketControl != null){
      if(self.OS.core_id != null && self.OS.core_id != "0") {
        self.socketControl.disconnect();
        self.socketControl.destroy();
        delete self.socketControl;
        self.connectSocket = false;
        self.socketControl = null;
      }
    }
  }
  this.createSocket = function(){
    self.logsSocket("SocketConnector", "------------------------------- createSocket ----------------------------");
    self.logsSocket("SocketConnector", self.namePlayer + "       "+self.OS.core_id);
    if(self.socketControl === null){
      self.logsSocket("SocketConnector", "------------------------------- createSocket socketControl = null ----------------------------");
      self.initSocket();
    }
    else{
      if(self.namePlayer != self.OS.core_id){
        self.logsSocket("SocketConnector", "------------------------------- createSocket ids distintos ----------------------------");
        self.disconnectSocket();
        setTimeout(function(){self.initSocket();}, 5000);
      }
    }
  }
  this.changeCore = function(id){
    self.logsSocket("SocketConnector", "---------------------------------changeCore--------------------------");
    self.logsSocket("SocketConnector", self.namePlayer + "       "+self.OS.core_id+ "     " + id);
    if(id != self.OS.core_id){
      self.logsSocket("SocketConnector", "---------------------------------changeCore - ids distintos --------------------------");
      self.OS.core_id = id;
      self.disconnectSocket();
      setTimeout(function(){self.initSocket();}, 5000);
    }
  }
}
//socketConnector.prototype = new SystemController();
