function DisplayController(Stage){
	var self = this; self.name = "DisplayController"; // MANDATORY

    this.stage = Stage;
    this.timetodie = 0; // Keep it to 0 , OLD Time To Die ... not so efficient : this.timetodie = 500;
    this.display_elements = {};
    this.template_elements = {};
		this.default_template = new DisplayTemplate(false,self,false);
		this.template = this.default_template;

    this.emergency_ref = 0;
    this.default_ref = 0;
    this.default_ref_exists = false;
    this.support_multi_video = false;
    this.support_preload_video = true;

    this.x = 0;
    this.y = 0;
    this.w = "100%";
    this.h = "100%";

    this.ui = false;

    this.display_tree = {};
    this.default_layer = 0;
		this.crossfade_time = 0;

    this.last_type = self.VIEWER_TYPE_VIDEO;
		this.triggerer_timer = false;

    this.init = function(emergency_content,ui){
        self.ui = ui;
        self.emergency_ref = self.addDisplayElement(emergency_content);
        self.setViewer();
				self.setVideoProperties();
    };

		this.setVideoProperties = function(smoothing){
				var use_multivideo = false;
				if(typeof(smoothing) !== "undefined"){
					if(smoothing == 0){
						use_multivideo = false;
					}else{
						use_multivideo = true;
						if(smoothing >= 1500 || smoothing == 0){
							self.crossfade_time = smoothing;							
						}
					}
				}
				if(self.platform == "SOC"){
						self.support_multi_video = false;
						self.support_preload_video = false;
						self.last_type = self.VIEWER_TYPE_VIDEO; // PREVENT VIDEO LOCK ON NONE MULTI-VIDEO
				}else if(self.platform == "WEBOS"){
						if(self.systemInfo.match(/chrome/i)){
							self.support_multi_video = use_multivideo;
							self.support_preload_video = use_multivideo;
						}else{
							// It's WEBOS2
							self.support_multi_video = false;
	            self.support_preload_video = false;
	            self.last_type = self.VIEWER_TYPE_VIDEO; // PREVENT VIDEO LOCK ON NONE MULTI-VIDEO
						}
				}else if(self.platform == "TIZEN"){
                    self.support_multi_video = use_multivideo;
                    self.support_preload_video = use_multivideo;
                    //self.last_type = self.VIEWER_TYPE_VIDEO; // PREVENT VIDEO LOCK ON NONE MULTI-VIDEO
                }else{
					self.support_multi_video = use_multivideo;
					self.support_preload_video = use_multivideo;
				}	
				if(self.support_preload_video && self.support_multi_video){self.timetodie = self.crossfade_time+200;}
				self.createVideo(0,true);
		};

    this.modifyEmergencyContent = function(ContentElement){
        self.default_ref = self.emergency_ref;
        if(ContentElement){
            self.default_ref = self.addDisplayElement(ContentElement);

            var filename = ContentElement.getSource();
            if(self.trim_path){
                filename = filename.substring(filename.lastIndexOf("/")+1,filename.length);
            }
            self.OS.fileExists(self.ROUTES['CONTENT'].path+filename,function(file_exists,file_ref){
                self.default_ref_exists = file_exists;
            });
        }
    };

    this.getDefaultDisplayReference = function(layer){
        layer = self.checkDisplayTreeLayerValue(layer);
        if(self.default_ref != self.emergency_ref){
            var filename = self.display_elements[layer][self.default_ref].content.getSource();
            if(self.trim_path){
                filename = filename.substring(filename.lastIndexOf("/")+1,filename.length);
            }
            self.OS.fileExists(self.ROUTES['CONTENT'].path+filename,function(file_exists,file_ref){
                self.default_ref_exists = file_exists;
            });
            if(self.default_ref_exists){
                return self.default_ref;
            }else{
                return self.emergency_ref;
            }
        }else{
            return self.emergency_ref;
        }
    };

    this.checkAvailability = function(ref,layer){
        var available = false;
        if(ref){
            layer = self.checkDisplayTreeLayerValue(layer);
              var filename = self.display_elements[layer][ref].content.getSource();
              if(self.trim_path){
                  filename = filename.substring(filename.lastIndexOf("/")+1,filename.length);
              }
              self.OS.fileExists(self.ROUTES['CONTENT'].path+filename,function(file_exists,file_ref,params){
                  self.display_elements[params.z][params.reference].available = file_exists;
              },{"reference":ref,"z":layer});
            available = self.display_elements[layer][ref].available;
						if(self.display_elements[layer][ref].invalidated){
							available = false;
						}
        }
        return available;
    };

    this.getDisplayElementController = function(ref,layer){
        layer = self.checkDisplayTreeLayerValue(layer);
        if(typeof(self.display_elements[layer][ref]) !== 'undefined'){
            var T = self.display_elements[layer][ref].type;
            var switcher = self.display_tree[layer][T].switch;
            self.log("Get Display Element Reference : "+ref+" on switch : "+switcher);
            return self.display_elements[layer][ref].controller[switcher];
        }else{
            return false;
        }
    };

    this.getDisplayContentElement = function(ref,layer){
        layer = self.checkDisplayTreeLayerValue(layer);
        if(typeof(self.display_elements[layer][ref]) !== 'undefined'){
            return self.display_elements[layer][ref];
        }else{
            return false;
        }
    };

    this.createVideo = function(layer,force){
				var reload = false;
				if(typeof(force) != "undefined"){reload = force;}
        var T = self.VIEWER_TYPE_VIDEO;
        if(self.display_tree[layer][T].html.length == 0 || reload){
            self.display_tree[layer][T].html[0] = 'video-primary-'+layer;
            if(self.support_multi_video){
                self.display_tree[layer][T].html[1] = 'video-secondary-'+layer;
            }else{
                self.display_tree[layer][T].html[1] = 'video-primary-'+layer;
            }
        }
    };

    this.createImage = function(layer){
        var T = self.VIEWER_TYPE_IMAGE;
				if(self.display_tree[layer][T].html.length == 0){
					self.display_tree[layer][T].html[0] = 'image-primary-'+layer;
					self.display_tree[layer][T].html[1] = 'image-secondary-'+layer;
				}
    };

    this.createFlash = function(layer){
        var T = self.VIEWER_TYPE_SWF;
				if(self.display_tree[layer][T].html.length == 0){
					self.display_tree[layer][T].html[0] = 'swf-primary-'+layer;
					self.display_tree[layer][T].html[1] = 'swf-secondary-'+layer;
				}
    };

    this.createIframe = function(layer){
        var T = self.VIEWER_TYPE_IFRAME;
        if(self.display_tree[layer][T].html.length == 0){
            self.display_tree[layer][T].html[0] = "iframe-primary-"+layer;
            self.display_tree[layer][T].html[1] = "iframe-secondary-"+layer;
        }
    };

    this.addDisplayElement = function(ContentElement,layer){
				ContentElement.setCrossfadeTime(self.crossfade_time);
        layer = self.checkDisplayTreeLayerValue(layer);
        if(typeof(self.display_tree[layer]) == "undefined"){
            self.display_tree[layer] = {"video":{"html":[],"prepare":true,"switch":0},
                                    "image":{"html":[],"prepare":true,"switch":0},
                                    "swf":{"html":[],"prepare":true,"switch":0},
                                    "iframe":{"html":[],"prepare":true,"switch":0}
                                   };
        }
        if(typeof(self.display_elements[layer]) === "undefined"){
            self.display_elements[layer] = [];
        }
        var id = parseInt(ContentElement.getId());
        if(typeof(self.display_elements[layer][id]) === "undefined"){
            self.display_elements[layer][id] = new DisplayContentElement();
            self.display_elements[layer][id].create(ContentElement,self.crossfade_time);
            self.display_elements[layer][id].setControllerReferences(id,layer,self.display_elements[layer][id].type);
            switch(self.display_elements[layer][id].type){
                case self.VIEWER_TYPE_VIDEO: self.createVideo(layer); break;
                case self.VIEWER_TYPE_IMAGE: self.createImage(layer); break;
                case self.VIEWER_TYPE_SWF: self.createFlash(layer); break;
                case self.VIEWER_TYPE_IFRAME: self.createIframe(layer); break;
            };
        }else{
            self.display_elements[layer][id].update(ContentElement);
        }
        return id;
    };

    this.addDisplayTemplate = function(TemplateElement){
        var id = 0;
        if(TemplateElement){
            var id = self.execute(function(){return TemplateElement.getId();});
            if(id){
                id = parseInt(id);
            }
        }
        if(id > 0){
            if(typeof(self.template_elements[id]) !== "undefined"){
                self.template_elements[id].data = TemplateElement;
                /*
                // TODO : IMPROVE
                var prev = ""+$(self.renderer.template_elements[id].data.data)[0].outerHTML;
                var post = ""+$(TemplateElement.data)[0].outerHTML;
                if(prev != post){
                    //self.renderer.template.unload(id); // OLD TODO: review template.unload()
                    self.renderer.template.unload();
                    self.renderer.template_elements[id].data = TemplateElement;
                    self.renderer.template.load();
                }
                */
            }else{
                self.template_elements[id] = null;
                self.template_elements[id] = new DisplayTemplate(TemplateElement,self,self.conditional);
            }
        }
        return id;
    };

    this.clear = function(){
        for(var tRef in self.template_elements){
            self.template_elements[tRef].unload();
        }
        for(var layer in self.display_elements){
            for(var element in self.display_elements[layer]){
                self.cancel_all(element,layer);
            }
        }
        if(self.ui){
            self.ui.unload();
        }
    };

    this.checkTemplate = function(DisplayTemplateRef){
        var displayTemplate = self.template_elements[DisplayTemplateRef];
        var testTemplate = self.execute(function(){return displayTemplate.data;});
        if(testTemplate){
            if(self.template.data){
                if(self.template.data.getId() != displayTemplate.data.getId()){
                    self.log("Content has ANOTHER a new template");
                    self.template.unload();
                    self.template = null;
                    self.template = displayTemplate;
                }else{
                    self.log("Content has SAME template ...");
                }
            }else{
                self.log("Content has NEW template");
                self.template.unload();
                self.template = null;
                self.template = displayTemplate;
            }
        }else{
            if(self.template.data){
                self.template.unload();
            }
            self.template = null;
            self.log("Content has NO template");
						self.template = self.default_template;
            //self.template = new DisplayTemplate(false,self,false);
        }
    };

    this.swap = function(layer,T){
        if(self.display_tree[layer][T].prepare){
            self.log(" --------------- SWAP --------------- ");
            self.display_tree[layer][T].prepare = false;
            self.display_tree[layer][T].switch = +!self.display_tree[layer][T].switch;
        }
        return self.display_tree[layer][T].switch;
    };

    this.preload = function(eRef,layer,die,viewer){
				if(typeof(viewer) === "undefined"){viewer = false;}    
        if(typeof(die) === "undefined"){die = true;}
        layer = self.checkDisplayTreeLayerValue(layer);
        if(eRef >= 0 && typeof(eRef) !== "boolean"){
            var T = self.display_elements[layer][eRef].type;
            var switcher = self.swap(layer,T);
            if(!self.support_multi_video && T == self.VIEWER_TYPE_VIDEO){
                if(self.last_type == T){
                    self.log(" --------------- NO PRELOAD SUPPORTED --------------- "+eRef);
                }else{
                    self.log(" --------------- PRELOAD ON NONE MULTIVIDEO --------------- ");
                    self.log("Preload Id : "+eRef+" on switch : "+switcher+" with tag : "+self.display_tree[layer][T].html[switcher]);
                    self.display_elements[layer][eRef].preload(switcher,self.display_tree[layer][T].html[0],viewer,die,self.timetodie);
                }
            }else{
                self.log(" --------------- PRELOAD ---------------");
                self.log("Preload Id : "+eRef+" on switch : "+switcher+" with tag : "+self.display_tree[layer][T].html[switcher]);
                self.display_elements[layer][eRef].preload(switcher,self.display_tree[layer][T].html[switcher],viewer,die,self.timetodie);
            }
        }
    };

    this.enable_events = function(eRef,layer,enable){
        if(layer == self.default_layer){
            $(self.display_elements[layer][eRef]).off("DisplayContentElementError",self.onDefaultElementError);
            $(self.display_elements[layer][eRef]).off("DisplayContentElementPlay",self.onDefaultElementPlaying);
            $(self.display_elements[layer][eRef]).off("DisplayContentElementFinish",self.onDefaultElementFinish);
            if(enable){
                $(self.display_elements[layer][eRef]).one("DisplayContentElementError",self.onDefaultElementError);
                $(self.display_elements[layer][eRef]).one("DisplayContentElementFinish",self.onDefaultElementFinish);
                $(self.display_elements[layer][eRef]).one("DisplayContentElementPlay",self.onDefaultElementPlaying);
            }
        }else{
            $(self.display_elements[layer][eRef]).off("DisplayContentElementError",self.onDefaultElementError);
            $(self.display_elements[layer][eRef]).off("DisplayContentElementPlay",self.onDefaultElementPlaying);
            if(enable){
                $(self.display_elements[layer][eRef]).one("DisplayContentElementError",self.onDisplayElementError);
                $(self.display_elements[layer][eRef]).one("DisplayContentElementPlay",self.onDisplayElementPlaying);
            }
        }
    };

    this.render = function(eRef,layer,die,screen){
        if(typeof(die) === "undefined"){die = true;}
        layer = self.checkDisplayTreeLayerValue(layer);
        if(eRef >= 0 && typeof(eRef) !== "boolean"){
            if(typeof(screen) === "undefined"){
                screen = self.template.getMasterElementScreen();
            }
            var T = self.display_elements[layer][eRef].type;
            var switcher = self.display_tree[layer][T].switch;

            self.enable_events(eRef,layer,true);
            self.log(" --------------- RENDER ---------------");
            self.log("Render Id : "+eRef+" on switch : "+switcher+" with tag : "+self.display_tree[layer][T].html[switcher]);
            if(!self.support_multi_video && T == self.VIEWER_TYPE_VIDEO){
                switcher = 0; // <-- Only One switcher available for video.
                if(layer == self.default_layer){
                    if(self.last_type == T){
                        self.display_elements[layer][eRef].direct_render(switcher,self.display_tree[layer][T].html[switcher],screen,die,self.timetodie);
                    }else{
                        if(self.display_elements[layer][eRef].controller[switcher].loaded){
                            self.display_elements[layer][eRef].render(switcher,screen,self.ui);
                        }else{
                            self.display_elements[layer][eRef].direct_render(switcher,self.display_tree[layer][T].html[switcher],screen,die,self.timetodie);
                        }
                    }
                }else{
                    self.log("WARNING : Trying to render multiple videos on an unsupported multi-video platform");
                    self.notifyError(self.ERROR['DISPLAY_CONTROLLER']+2,self.name+": Trying to render multiple videos on an unsupported multi-video platform");
                }
            }else{
                if(self.display_elements[layer][eRef].controller[switcher].loaded){
                    self.display_elements[layer][eRef].render(switcher,screen,self.ui);
                }else{
                    self.display_elements[layer][eRef].direct_render(switcher,self.display_tree[layer][T].html[switcher],screen,die,self.timetodie);
                }
            }
            self.last_type = T;
            self.display_elements[layer][eRef].active_switcher = switcher;
        }
    };
		
		this.refresh = function(eRef,layer,screen){
			layer = self.checkDisplayTreeLayerValue(layer);
			if(eRef >= 0 && typeof(eRef) !== "boolean"){
				if(typeof(screen) != "undefined"){
					var T = self.display_elements[layer][eRef].type;
					var switcher = self.display_tree[layer][T].switch;
					self.display_elements[layer][eRef].refresh(switcher,screen);
				}
			}
		};

    this.prepare_scene = function(tRef,eRef,die,layer){
        self.log(" --------------- PREPARE SCENE ---------------");
        if(typeof(die) === "undefined"){die = true;}
				var screen = self.convertCoordinates({w:self.w,h:self.h},{w:self.w,h:self.h},{x:0,y:0,w:self.w,h:self.h});
        if(typeof(self.template_elements[tRef]) !== "undefined"){
						screen = null;
            self.template_elements[tRef].load();
            screen = self.template_elements[tRef].getMasterElementScreen();
        }
        var layer = self.checkDisplayTreeLayerValue(layer);
        var T = self.display_elements[layer][eRef].type;
        var direct = false;
        if(T == self.VIEWER_TYPE_VIDEO){
            if(self.support_preload_video){
                self.preload(eRef,layer,die,screen);
            }else{
                self.swap(layer,T);
                direct = true;
            }
        }else{
            self.preload(eRef,layer,die,screen);
        }
        var switcher = self.display_tree[layer][T].switch;
        var tag = self.display_tree[layer][T].html[switcher];
        var scene = {
            screen : screen,
            content : self.display_elements[layer][eRef],
            template_ref : tRef,
            switcher : switcher,
            tag : tag,
            force_direct : direct,
            die: die,
						is_trigger: false
        };
				
        return scene;
    };

    this.render_scene = function(scene,previous_scene){
				self.log("SysInfo : ");
				self.log(self.systemInfo);
        self.log(" --------------- RENDER SCENE ---------------");
        self.enable_events(scene.content.reference,scene.content.layer,true);
        if(scene.force_direct){
            if(previous_scene){
							previous_scene.content.controller[previous_scene.switcher].vanish();
							if(scene.die){
								previous_scene.content.controller[previous_scene.switcher].destroy(0);
							}
						}
            scene.content.direct_render(scene.switcher,scene.tag,scene.screen,scene.die,self.timetodie);
        }else if(scene.content.controller[scene.switcher].loaded){
            scene.content.render(scene.switcher,scene.screen,self.ui);
            if(previous_scene){
							previous_scene.content.controller[previous_scene.switcher].vanish();
							if(scene.die){
								previous_scene.content.controller[previous_scene.switcher].destroy(self.timetodie);
							}
						}
        }else{
            scene.content.cancel_preload(scene.switcher);
            if(previous_scene){
							previous_scene.content.controller[previous_scene.switcher].vanish();
							if(scene.die){
								previous_scene.content.controller[previous_scene.switcher].destroy(self.timetodie);
							}
						}
            scene.content.direct_render(scene.switcher,scene.tag,scene.screen,scene.die,self.timetodie);
        }
        self.checkTemplate(scene.template_ref);
        self.template.render();
        previous_scene = null;
        return scene;
    };

		this.triggerDisplayControllerElementStarted = function(){
				clearTimeout(self.triggerer_timer);
				$(self).trigger("DisplayControllerElementStarted");
		};

    this.onDefaultElementPlaying = function(e){
        var T = self.display_elements[e.currentTarget.layer][e.currentTarget.reference].type;
        self.display_tree[e.currentTarget.layer][T].prepare = true;
        $(e.currentTarget).off("DisplayContentElementPlay");
        self.triggerer_timer = setTimeout(self.triggerDisplayControllerElementStarted,1000);
    };

    this.onDisplayElementPlaying = function(e){
        var T = self.display_elements[e.currentTarget.layer][e.currentTarget.reference].type;
        self.display_tree[e.currentTarget.layer][T].prepare = true;
    };

    this.onDefaultElementError = function(e){
    	self.OS.id_content_now = "";
        var T = self.display_elements[e.currentTarget.layer][e.currentTarget.reference].type;
        self.display_elements[e.currentTarget.layer][e.currentTarget.reference].available = false;
				self.display_elements[e.currentTarget.layer][e.currentTarget.reference].invalidated = true;
        self.display_tree[e.currentTarget.layer][T].prepare = true;
        $(e.currentTarget).off("DisplayContentElementError");
        var filename = self.display_elements[e.currentTarget.layer][e.currentTarget.reference].content.getSource();
        if(self.trim_path){
            filename = filename.substring(filename.lastIndexOf("/")+1,filename.length);
        }
        self.OS.fileExists(self.ROUTES['CONTENT'].path+filename,function(file_exists,file_ref,params){
            if(file_exists){
                self.log("Can be a corrupt file : "+file_ref);
                //self.OS.deleteFile(file_ref);
                if(typeof(params) !== "undefined"){
                    self.display_elements[params.layer][params.ref].available = false;
                }
                self.notifyError(self.ERROR['DISPLAY_CONTROLLER']+3,self.name+": Can be a corrupt file : "+self.ROUTES['CONTENT'].path+file_ref);
            }
        },{ref:e.currentTarget.reference,layer:e.currentTarget.layer});
        $(self).trigger("DisplayControllerElementError");
        self.notifyError(self.ERROR['DISPLAY_CONTROLLER']+1,self.name+": Function onDefaultElementError() failed");
    };

    this.onDisplayElementError = function(e){
        var T = self.display_elements[e.currentTarget.layer][e.currentTarget.reference].type;
        self.display_elements[e.currentTarget.layer][e.currentTarget.reference].available = false;
        self.display_tree[e.currentTarget.layer][T].prepare = true;
        $(e.currentTarget).off("DisplayContentElementError");
        self.notifyError(self.ERROR['DISPLAY_CONTROLLER']+1,self.name+": Function onDisplayElementError() failed");
    };

    this.onDefaultElementFinish = function(e){
        self.enable_events(e.currentTarget.reference,e.currentTarget.layer,false);
        $(self).trigger("DisplayControllerElementFinish");
    };

    this.checkUi = function(display_element_reference,layer){
        layer = self.checkDisplayTreeLayerValue(layer);
        if(typeof(self.display_elements[layer][display_element_reference]) !== "undefined"){
            var element = self.getDisplayElementController(display_element_reference,layer);
            if(!element.ui){
                element.connect(self.ui);
            }
        }
    };

    this.cancel = function(eRef,layer,force){
        if(typeof(force) == "undefined"){force = false;}
        layer = self.checkDisplayTreeLayerValue(layer);
				if(typeof(self.display_elements[layer]) !== "undefined"){
	        if(typeof(self.display_elements[layer][eRef]) !== "undefined"){
	            self.display_elements[layer][eRef].cancel(self.display_elements[layer][eRef].active_switcher,force);
	        }
				}
    };

    this.cancel_all = function(eRef,layer,force){
        if(typeof(force) == "undefined"){force = false;}
        layer = self.checkDisplayTreeLayerValue(layer);
				if(typeof(self.display_elements[layer]) !== "undefined"){
					if(typeof(self.display_elements[layer][eRef]) !== "undefined"){
	            self.enable_events(eRef,layer,false);
	            self.display_elements[layer][eRef].cancel(0,force);
	            self.display_elements[layer][eRef].cancel(1,force);
	        }
				}
    };

    this.modifyViewer = function(x,y,w,h){
        self.x = x;
        self.y = y;
        self.w = w;
        self.h = h;
        self.setViewer();
    };

    this.setViewer = function(){
        self.stage.css("left",self.x);
        self.stage.css("top",self.y);
        self.stage.css("width",self.w);
        self.stage.css("height",self.h);
    };

    this.checkDisplayTreeLayerValue = function(layer){
        if(typeof(layer) == "undefined"){
            layer = self.default_layer;
        }else if(isNaN(layer) || typeof(layer) == "boolean"){
            layer = self.default_layer;
        }else{
            layer = parseInt(layer);
        }
        return layer;
    };
		
		this.convertCoordinates = function(window,patern,screen){
        var x_factor = window.w/patern.w;
        var y_factor = window.h/patern.h;
        if(!isNaN(screen.x)){screen.x = screen.x*x_factor; screen.x = Math.round(screen.x * 1000) / 1000;}
        if(!isNaN(screen.y)){screen.y = screen.y*y_factor; screen.y = Math.round(screen.y * 1000) / 1000;}
        if(!isNaN(screen.w)){screen.w = screen.w*x_factor; screen.w = Math.round(screen.w * 1000) / 1000;}
        if(!isNaN(screen.h)){screen.h = screen.h*y_factor; screen.h = Math.round(screen.h * 1000) / 1000;}
        return screen;
    };

}
DisplayController.prototype = new SystemController();
