function OperatingSystemController(){
    if(arguments.callee._singletonInstance){
	    return arguments.callee._singletonInstance;
	}
	arguments.callee._singletonInstance = this;
    
	var self = this; self.name = "OperatingSystemController"; // MANDATORY
    this.rootDir = "";
    
    this.init = function(callback){
        // OVERRIDE
        callback();
    };
    
    this.writeFile = function(filename,value,callback,params){
        // OVERRIDE
        self.log("Writting '"+filename+"' value: ");
        self.log(value);
        
        if(typeof(callback) !== "undefined"){
            callback(true,path,params);
        }        
    };
    
    this.appendFile = function(filename,value,callback,params){
        // OVERRIDE
        self.log("Appending '"+filename+"' value: ");
        self.log(value);
        
        if(typeof(callback) !== "undefined"){
            callback(true,path,params);
        }        
    };
    
    this.readFile = function(filename,callback,params){
        if(typeof(callback) !== "undefined"){
            callback("",filename,params);
        }
    };
    
    this.fileExists = function(filename,callback,params){
        // OVERRIDE
        if(typeof(callback) !== "undefined"){
            callback(true,filename,params);
        }  
    };
    
    this.makeDir = function(path,callback,params){
        // OVERRIDE
        if(typeof(callback) !== "undefined"){
            callback(true,path,params);
        }
    };

    this.modificationDate = function(filename,callback,params){
        // OVERRIDE
        //var date = new Date(0).getTime();
        var date = filename.replace("datos.xml?","");
        if(typeof(callback) !== "undefined"){
            callback(date,filename,params);
        }
    };
    
    this.downloadFile = function(url,destFolder,callback,params){
        // OVERRIDE
    };
    
    this.unzipFile = function(filename,destFolder,callback,params){
        // OVERRIDE
    };
    
    this.readDirectory = function(directory,callback,params){
        // OVERRIDE
    };
    
    this.deleteFile = function(filename,callback,params){
        // OVERRIDE
    };
    
    this.moveFile = function(source,destination,callback,params){
        // OVERRIDE
    };
    
    this.takeScreenshot = function(callback,params){
        // OVERRIDE 
    };
    
    this.setSystemDateTime = function(timestamp,callback,params){
        // OVERRIDE
    };
    
    this.requestSystemTimestamp = function(){
        return parseInt(new Date().getTime()/1000);
    };
        
    this.rebootSystem = function(){
        // OVERRIDE   
    };
    
    this.getScreens = function(){
        // OVERRIDE 
        var screens = [];
        screens[0] = {id:0,bounds:{x:0,y:0,width:400,height:300,scaleFactor:1}};
        return screens;
    };

    this.setWindow = function(x,y,w,h){  
        // OVERRIDE  
    };
    
    this.setProxyConfig = function(config){
        // OVERRIDE  
    };
    
    this.getProxyForURL = function(url){
        // OVERRIDE 
        return "";
    };  
    
    this.getAddWhiteList = function(sourceOrigin, destinationProtocol, destinationHost, allowDestinationSubdomains){
        // OVERRIDE  
    };
    
    this.getRemoveWhiteList = function(sourceOrigin, destinationProtocol, destinationHost, allowDestinationSubdomains){
        // OVERRIDE  
    };
    
    this.getDataPath = function(){
         // OVERRIDE  
    };
    
    this.setCrashDumpPath = function(folderPath){
         // OVERRIDE  
    };

    this.quit = function(){
        // OVERRIDE  
    };
    
    this.clearCache = function(){
        // OVERRIDE  
    };
    
    this.alwaysOnTop = function(value){
        // OVERRIDE  
    };
    
    this.focusWindow = function(){
        // OVERRIDE  
    };
    
    this.activateControl = function(){
        // OVERRIDE  
    };
    this.deactivateControl = function(){
        // OVERRIDE  
    };
    this.sendControlLog = function(name, text){
        // OVERRIDE  
    };
    this.saveIdContent = function(idContent){
        self.id_content_now = idContent;
    };
}	
OperatingSystemController.prototype = new SystemController();
