function ConfigElement(data){
    this.class = "ConfigElement"; // MANDATORY
	this.data = data;

    this.getId = function(){
		return this.data.attr('plv_id');
	};

    this.getDebugMode = function(){
        var debug = false;
        if(this.data.attr('debug') == "true"){
            debug = true;
        }
		return debug;
    };

    this.getVolume = function(){
        var volume = 1.0;
        if(this.data.attr('volume') != ""){
            volume = parseInt(this.data.attr('volume'))/100;
        }
		return volume;
    };

    this.getMode = function(){
		return parseInt(this.data.attr('mode'));
    };

    this.getModeTime = function(){
		return parseInt(this.data.attr('time'));
    };

    this.getSyncPort = function(){
		return parseInt(this.data.attr('time'));
    };

    this.getSyncMachines = function(){
      var sync_machines = -1;
      if(typeof(this.data.attr('sync_machines')) !== "undefined"){
        sync_machines = parseInt(this.data.attr('sync_machines'));
      }
      return sync_machines;
    };

    this.getQuitOnClickOption = function(){
        var quitOnClick = false;
        if(this.data.attr('quit_on_click') == "true"){
            quitOnClick = true;
        }
		return quitOnClick;
    };

    this.getRefreshTime = function(){
        var refresh = parseInt(this.data.attr('system_beat_refresh'));
        if(isNaN(refresh)){
          refresh = 1;
        }else if(refresh < 1){
            refresh = 1;
        }
        return refresh;
    };

    this.getDefaultContent = function(){
        var transition = 0;
        var content = parseInt(this.data.attr('transition_content'));
        if(!isNaN(content)){
            transition = content;
        }
        return this.data.attr('transition_content');
    };

    this.getApiKey = function(){
        return this.data.attr('api_key');
    };

    this.getActivationStatus = function(){
        var isActivated = true;
        if(this.data.attr('activated') == "false"){
            isActivated = false;
        }

        return isActivated;
    };

    this.getDomain = function(){
        return this.data.attr('domain');
    };

    this.getQuitOnClick = function(){
        var quit_on_click = true;

        if(this.data.attr('quit_on_click') == "false"){
            quit_on_click = false;
        }
        return quit_on_click;
    };

    this.getAlwaysOnTop = function(){
        var isAlwaysOnTop = true;
        if(this.data.attr('always_on_top') == "false"){
            isAlwaysOnTop = false;
        }
        return isAlwaysOnTop;
    };

    this.getPlayerInfo = function(){
        var player_info = {
            id:0,
            name:"",
            project:"",
            api_key:""
        };
        if(this.data.attr('plv_id') !== "undefined"){
            player_info.id = this.data.attr('plv_id');
        }
        if(this.data.attr('plv_name') !== "undefined"){
            player_info.name = this.data.attr('plv_name');
        }
        if(this.data.attr('project_name') !== "undefined"){
            player_info.project = this.data.attr('project_name');
        }
        if(this.data.attr('api_key') !== "undefined"){
            player_info.api_key = this.data.attr('api_key');
        }

        return player_info;
    };

    this.getScreenConfig = function(){
        var isFullscreen = this.data.attr('fullscreen');
        if(isFullscreen == "false"){
            var resolution = this.data.find('resolution');
            return {x:resolution.attr('x'),y:resolution.attr('y'),w:resolution.attr('width'),h:resolution.attr('height')};
        }else{
            return {x:0,y:0,w:"100%",h:"100%"};
        }
    };

    this.convertHexScheduleToArray = function(hexSchedule){
        var index = 0;
        var timetable = new Array(168);
        try{
            for(var i=0;i<168;i++){
          		timetable[i]=0;
          	}
            var lookupTable = {
                '0': '0000', '1': '0001', '2': '0010', '3': '0011',
                '4': '0100', '5': '0101', '6': '0110', '7': '0111',
                '8': '1000', '9': '1001', 'a': '1010', 'b': '1011',
                'c': '1100', 'd': '1101', 'e': '1110', 'f': '1111'
            };
            for(var i=0;i<7;i++){
                var aux = hexSchedule.substring(i*6,i*6+6);
                for(var j=0;j<aux.length;j++){
                    timetable[index] = parseInt(lookupTable[aux[j]][0]);index++;
                    timetable[index] = parseInt(lookupTable[aux[j]][1]);index++;
                    timetable[index] = parseInt(lookupTable[aux[j]][2]);index++;
                    timetable[index] = parseInt(lookupTable[aux[j]][3]);index++;
                }
            }
            return timetable;
        }
        catch(e){
            return timetable;
        }
    };

    this.getScheduleConfig = function(){
        var schedule = false;
        var schedule_xml = this.data.find('schedule');
        if(typeof(schedule_xml) !== "undefined"){
            if(typeof(schedule_xml.attr('schedule')) !== "undefined"){
                schedule = {
                    timetable: this.convertHexScheduleToArray(schedule_xml.attr('schedule')),
                    halt: parseInt(schedule_xml.attr('halt')),
                    delay: parseInt(schedule_xml.attr('delay'))
                }
            }
        }
        return schedule;
    };

    this.getAdvancedOrientation = function(){
      //return parseInt(this.data.attr('advanced_video_deblocking'));
      return 0;
    };
    this.getForceReboot24h = function(){
      return parseInt(this.data.attr('advanced_video_deblocking'));
    }
    this.getAdvancedVideoSmoothing = function(){
        var smoothing = parseInt(this.data.attr('advanced_video_smoothing'));
        if(smoothing > 1 && smoothing < 1500){
          smoothing = 1;
        }
        return smoothing;
    };
    
    this.getAdvancedPlaylistJump = function(){
      if(parseInt(this.data.attr('advanced_playlist_mode_jump')) == 1){
        return true;
      }else{
        return false;
      }
    };

    this.getOnScreenAlertsConfig = function(){
        var onScreenAlertConfig = false;

        var liveUrl = this.data.attr('live_url');
        if(liveUrl != ""){
            onScreenAlertConfig = {
                url : liveUrl,
                send_id : false,
                interval : 30000
            };

            var liveSendId = this.data.attr('live_send_id');
            if(liveSendId == "1"){
                onScreenAlertConfig.send_id = true;
            }
            var liveRecheckSeconds = parseInt(this.data.attr('live_recheck_seconds'));
            if(!isNaN(liveRecheckSeconds)){
                onScreenAlertConfig.interval = liveRecheckSeconds*1000;
            }

        }

        return onScreenAlertConfig;
    };
}
