function TemplateElement(data){
    this.class = "TemplateElement"; // MANDATORY
	this.data = data;
    this.elements = [];
    
    this.available = false;
    
    this.addElement = function(element){
        this.elements.push(element);
    };
    
    this.getElementIndex = function(index){
        return this.elements[index];
    }
    
    this.getId = function(){
		return parseInt(this.data.attr('id'));
	}; 
    
    this.getMasterSize = function(){
        var x = parseInt(this.data.attr('master_x'));
        var y = parseInt(this.data.attr('master_y'));
        var w = parseInt(this.data.attr('master_w'));
        var h = parseInt(this.data.attr('master_h'));
        var z = parseInt(this.data.attr('z_order'));
      
        return {x:x,y:y,w:w,h:h,z:z};
    };
    
    this.getMasterPaternSize = function(){
        var w = parseInt(this.data.attr('width'));
        var h = parseInt(this.data.attr('height'));
      
        return {w:w,h:h};
    };
    
    this.getElementSize = function(index){
        var element = $(this.data).find("template_item").eq(index);
        var x = parseInt(element.attr('x'));
        var y = parseInt(element.attr('y'));
        var w = parseInt(element.attr('w'));
        var h = parseInt(element.attr('h'));
        var z = parseInt(element.attr('z_order'));
      
        return {x:x,y:y,w:w,h:h,z:z};
    };
    
    this.unload = function(){
        for(var i=0;i<this.elements.length;i++){
            this.elements[i] = null;
        }
        this.elements = null;
    };
    
    this.loadTemplateContentItems = function(DataManager,conditional){      
        var items = this.data.find("template_item");
        for(var i=0;i<items.length;i++){
            var item = DataManager.getArchiveFileItemById($(items[i]).attr('content_id'));
            if(!item){
                var item_id = $(items[i]).attr('content_id');
                if(item_id != ""){
                    item = DataManager.getBlockById(item_id);
                    if(!item){
                        item = false;
                    }else{
                        item.addContentElements(DataManager,conditional);
                    }
                }else{
                    item = false;
                }
            }
            this.addElement(item);        
        }
    };
}
