'use strict';

var node_process = require('process');
var node_main = node_process.mainModule.exports;

var player = false;

// FOR ARM ARCH
var transfer = false;
var manager = false;


var beat_timer = false;
var service_timer = false;

var last_mouse_pos_x = 0;
var last_mouse_pos_y = 0;
var lastUserActivity = 0;
var main_win = false;

if(typeof(nw) === "undefined"){
    nw = require('nw.gui');
}

if(typeof(nw) !== "undefined"){
  main_win = nw.Window.get();
  if(main_win.title != "player"){
    main_win.hide();
    nw.Screen.Init();

    var screens = nw.Screen.screens;
    var width = 0;
    var height = 0;

    for(var i=0;i<screens.length;i++){
        var screen_width = screens[i].bounds.x + screens[i].bounds.width;
        if(screen_width > width){
            width = screen_width;
        }
        var screen_height = screens[i].bounds.y + screens[i].bounds.height;
        if(screen_height > height){
            height = screen_height;
        }
    }
    
    nw.Window.open("admira.html",{
      frame: false,
      title: "player",
      width: width,
      height: height,
      transparent: false,
      fullscreen: false,
      kiosk: false,
      show: true,
      visible_on_all_workspaces: false,
      always_on_top: true,
      resizable: false
    },function(win){
      main_win.close(true);
    });
  }
}

function adaptPlayerWindowSize(){
  if(player){
    if(player.config){
      var is_fixed_size = false;
      var screen = player.config.getScreenConfig();
      if(screen.w == "100%"){
        screen.w = window.innerWidth;
      }else{
        is_fixed_size = true;
      }
      if(screen.h == "100%"){
        screen.h = window.innerHeight;
      }else{
        is_fixed_size = true;
      }
      if(is_fixed_size){
        player.OS.setMaxWindowDesktop(screen);
        player.setPlayerWindow();
      }else{
        player.OS.setMaxWindowDesktop();
        player.setPlayerWindow();
      }
    }
  }
}


$(document).ready(function(){
    if(main_win.title == "player"){
      if(!service_timer){
          service_timer = setInterval(service,20000);
      }

      if(!player){
          player = new PlayerController();
          //player.activateLogger(true);
          $(player).on("PlayerDataLoaded",onPlayerDataLoaded);
          player.init();
          adaptPlayerWindowSize();
      }
      $(window).keypress(function(event){
          //console.log("KeyPress Code = "+event.which+" Shifted = "+self.keyboardShifted);
          lastUserActivity = parseInt(player.getDate().getTime()/1000);
      });

      $(window).on("mousemove",function(event) {
          //console.log("Mouse MOVE !!");
          lastUserActivity = parseInt(player.getDate().getTime()/1000);
      });
    }
});

function beat(){
    /*
    var clipboard = nw.Clipboard.get();
    var clipboard_data = clipboard.get('text');
    if(clipboard_data == "1"){
        lastUserActivity = parseInt(player.getDate().getTime()/1000);
    }
    clipboard.clear();
    */
    if(!player.OS.window_showing){
        var mouse_pos = player.OS.getMousePos();
        if(mouse_pos){
          if(mouse_pos.x != last_mouse_pos_x || mouse_pos.y != last_mouse_pos_y){
            last_mouse_pos_x = mouse_pos.x;
            last_mouse_pos_y = mouse_pos.y;
            lastUserActivity = parseInt(player.getDate().getTime()/1000);
          }
        }
        var playerMode = player.config.getMode();
        var playerModeTime = player.config.getModeTime();
         //console.log("NWJS Window beat! mode : "+playerMode+" : "+playerModeTime);
        if(playerMode == "1"){ // SCREENSAVER
            var now = parseInt(player.getDate().getTime()/1000);
            console.log("Now : "+now+" Last Activity : "+lastUserActivity);
            var spentTimeSinceLastActivity =  now - lastUserActivity;
            console.log("Spent Time : "+spentTimeSinceLastActivity);
            if(spentTimeSinceLastActivity > playerModeTime){
                console.log("Show Window !");
                if(!player.OS.window_showing){
                  player.OS.recover();
                  player.OS.togglePlayerMenu();
                }
            }
        }
    }
}

function service(){
    player.service();
    var playerMode = player.config.getMode();
    if(playerMode != "1" && !player.OS.player_paused_by_user){
        player.OS.recover();
        //player.OS.togglePlayerMenu();
    }
    adaptPlayerWindowSize();
}


function onPlayerDataLoaded(){
    //player.OS.setMaxWindowDesktop();
    //player.setPlayerWindow();
    adaptPlayerWindowSize();
    if(!beat_timer){
        beat_timer = setInterval(beat,1000);
    }

    player.log("LINUX Architecture is ARM : "+player.OS.isARM);
    if(!player.OS.isARM){
        node_main.init();
        node_main.update(player.timestamp,player.dataManager.getArchiveFiles(),player.version,player.debug,player.config.getScheduleConfig(),player.playlist.conditional);
    }else{
        if(!transfer){
            transfer = new TransferService();
            transfer.init(player.version);
        }
        transfer.update(player.timestamp,player.dataManager.getArchiveFiles());
        transfer.activateLogger(player.debug);
        if(!manager){
            manager = new ManagerService();
            manager.init();
        }
        manager.update(player.config.getScheduleConfig());
        manager.activateLogger(player.debug);
    }

    /* NOT NWJS 0.12 compatible
    chrome.runtime.sendMessage({action:"start",value:{core_id:player.core_id,version:player.version,timestamp:player.timestamp,archive:player.dataManager.getArchiveFiles()}}, function(val) {
            console.log("Chrome API : update Transfer");
    });
    */
}
