/*
TODO Remote formating
TODO console.log
TODO logging
*/ 


function BasicScreenController(){
	var self = this; self.name = "BasicScreenController"; // MANDATORY
	
	// Vars
	this.data = {
		internal_id: null, // Used in error control
        id : null,
        remote_id : null,
        hex_remote_id : null,
        model : null
    }
    this.status = {
        power : -1,
        channel : " ",
        lastCMD : " ",
        tstamp : 0
    }
    this.config = {
        schedule : null,
        delay : 0
    }

    this.exceptions = {
        yesterday : {
            id : -1,
            schedule : -1,
            type : -1,
            copyday : -1,
            day : -1,
        },
        today : {
            id : -1,
            schedule : -1,
            type : -1,
            copyday : -1,
            day : -1
        },
        splitTime : 5  //hour after which the schedulle obeys today exception instead of yesterdays
    }


    this.intervals = {
            power : 20000,
            channel : 60000,
            schedule : 30000	
    }
    this.errCounter = {
        power : 0,
        channel : 0,
        schedule : 0
    };
    this.maxAttemptsSend = {
            power : 0,
            channel : 0,
            schedule : 0
    };
    this.attemptsCounter = {
            power : 0,
            channel : 0,
            schedule : 0
    };

    this.protocol = null;
    this.driver = null;
    this.stopping = false;

    this.forceSchedulle = true; 
    /* empty config */
    this.portValues = {
    		name : '',
    	    config : {
		            baudRate : 0,
		            dataBits : 0,
		            stopBits : 0
		    },
		    parser : {
	    		type : '' ,
	            delimiter : 0 
		    }	
    }

    this.timers = {
        power : 0,
        channel : 0,
        schedule : 0
    }
    
    this.freeCmd = {};
    this.freeCommandCallback = function (){return};
    
    /******************************** SPECIAL CHARACTERS ********************************/
    this.STX = Buffer.from ( '02' , 'hex');
    this.ETX = Buffer.from ( '03' , 'hex');

    this.samsungSTX = Buffer.from ( 'AA' , 'hex' );
    
    /******************************** STATUS ********************************/
    this.getStatus = function () {
    	var status = false;
        status = { 
        	"int_id"	:	self.data.internal_id,
    		"id_screen"	:	self.data.id,
			"port"		:	self.portValues.name,
			"schedule"	:	{ 
								"delay"	:	self.config.delay,
								"halt"	:	false
							},
			"brand"		:	self.data.model,
			"remote_id"	:	self.data.remote_id,
			"status"	:	self.status.power,
			"channel"	:	self.status.channel,
			"lastCMD"	:	self.status.lastCMD,
			"tstamp"	:	self.status.tstamp,
			"errors"	:	0
        }
    	return status;
    }

    this.setStatus = function ( power, channel, lastCMD, tstamp ) {
        self.status.power   = power;
        self.status.channel = channel;
        self.status.lastCMD = lastCMD;
        self.status.tstamp  = tstamp;
    }
	    
    /*********************************** INIT FUNCTIONS ***********************************/
    this.formatRemoteId = function ( id ) { return id; };
    this.loadDriver = function ( platform ) { return };
    this.testingName = function (  ) { console.log ("testingName") };

    this.init = function ( screen, exceptions, platform, architecture, counter ){
    	self.data.internal_id = counter;
        self.data.id = screen.id;
        self.data.remote_id = screen.remote_id;
        self.data.formated_remote_id  = self.formatRemoteId( screen.remote_id );
        self.data.model = screen.model;
        
        self.portValues.name = screen.port;
        self.config.schedule = self.getBinSchedule(screen.schedule);
        if ( screen.exceptions.length > 0 && exceptions.length > 0 ){
            self.checkExceptions ( screen.exceptions, exceptions );
            self.applyExceptions();
        }
        
        
        self.driver = self.loadDriver();
        self.driver.init ( platform, architecture )
        
        //START CONTROL TIMERS
        if (screen.id == 0 ){
            self.stopping = true;
        }else {
            self.stopping = false;
            self.start();
        }
        
        return true;
    }
    
    /*********************************** CONTROL FUNCTIONS ***********************************/
    this.start = function (){
    	self.stopping = false;

        clearTimeout ( self.timers.power );
        if (self.timers.power){
            self.checkPowerStatus();
        	//self.timers.power = setTimeout ( self.checkPowerStatus , self.intervals.power );
        }

        clearTimeout ( self.timers.channel );
        if (self.timers.channel){
            self.checkChannelStatus();
        	//self.timers.channel = setTimeout ( self.checkChannelStatus , self.intervals.channel );
        } 

        clearTimeout ( self.timers.schedule );
    	if (self.timers.schedule){
            self.checkSchedule();
    		//self.timers.schedule = setTimeout ( self.checkSchedule , self.intervals.schedule );
    	}

    }
    
    this.stop = function (){
    	self.stopping = true;

        clearTimeout ( self.timers.power );
        clearTimeout ( self.timers.channel );
    	clearTimeout ( self.timers.schedule );      
    }
    
    /*********************************** LOOPS FUNCTIONS ***********************************/
    /*********************************** POWER ***********************************/
    this.generatePowerQuerry   = function (){ return "";};
    this.translatePowerQuerry  = function ( data ){ return; };
    this.endPowerQuerry        = function (){ return; };

    this.checkPowerStatus = function () {
        //console.log ( new Date() + ' - ' + self.name + ', screen: '+ self.data.id + " : Start check power // Internal_ID: " + self.data.internal_id  );
        self.log ( 'id: ' + self.data.id + ' : Power Querry' );
        self.attemptsCounter.power = 0;
        var command = self.generatePowerQuerry();
        self.log ( 'id: ' + self.data.id + ' : Power Querry Command: ' + command.toString('hex') );
        self.driver.send ( command , self.portValues, self.checkPowerStatusCallback );
    }
    //Private Callback
    this.checkPowerStatusCallback = function (err, data, checkTstamp, callback ){
        self.attemptsCounter.power++;
        if (err){
            //console.log ( new Date() + ' - ' + self.name + ', screen: '+ self.data.id + " : ERROR check power status: " + err + " // Internal_ID: " + self.data.internal_id );
            self.log ( 'id: ' + self.data.id + ' : Power Error : ' + err );
            self.errorHandling ( err );

            if ( self.attemptsCounter.power < self.maxAttempts.power ){
                callback ("retry", checkTstamp, self.relaunchPowerLoop );

            }else {
                if (self.errCounter.power < 3 ){
                    self.errCounter.power++;
                }else {
                    self.errCounter.power = 0;
                    self.status.power = -1;
                    self.status.tstamp = Math.floor(new Date().getTime()/1000);
                }
                callback ("next", checkTstamp, function (){return;} );
                self.relaunchPowerLoop();
            }

            return;
        }

        //console.log ( new Date() + ' - ' + self.name + ', screen: '+ self.data.id + " : Result check power status: " + data + " // Internal_ID: " + self.data.internal_id );    
        self.log ( 'id: ' + self.data.id + ' : Power Response : HEX: ' + data.toString('hex') + ' | UTF8: ' + data.toString('utf8') );
        self.errCounter.power = 0;
        //Translate Result to self.status.power
        self.translatePowerQuerry( data )
        
        //console.log ( new Date() + ' - ' + self.name + ', screen: '+ self.data.id + " : Result check power status: " + self.status.power + " // Internal_ID: " + self.data.internal_id );    
                

        if ( self.attemptsCounter.power < self.maxAttempts.power ){
            callback ("retry", checkTstamp, self.relaunchPowerLoop );
        }else {
            callback ("next", checkTstamp, function (){return;} );
            self.relaunchPowerLoop();
        }
        // Special Callback End
        self.endPowerQuerry();
    }

    this.relaunchPowerLoop = function (){
        clearTimeout ( self.timers.power );
        if (!self.stopping && self.timers.power ) {
            self.timers.power = setTimeout ( self.checkPowerStatus , self.intervals.power );
        }
        return;
    }
    
/********************************** CHANNEL **********************************/
    this.generateChannelQuerry  = function (){ return ""; };
    this.translateChannelQuerry = function ( data ){ return; };
    this.endChannelQuerry       = function (){ return; };

    this.checkChannelStatus = function (){
        //console.log ( new Date() + ' - ' + self.name + ', screen: '+ self.data.id + " : Start check channel status // Internal_ID: " + self.data.internal_id );
        self.log ( 'id: ' + self.data.id + ' : Channel Querry' );
        var command = self.generateChannelQuerry();
        self.driver.send ( command , self.portValues, self.checkChannelStatusCallback );

    }

    //Private Callback
    this.checkChannelStatusCallback = function (err, data, checkTstamp, callback){
        self.attemptsCounter.channel++;
        if (err){
            //console.log ( new Date() + ' - ' + self.name + ', screen: '+ self.data.id + " : ERROR check channel status: " + err );
            self.log ( 'id: ' + self.data.id + ' : Channel Error : ' + err );
            self.errorHandling ( err );

            if ( self.attemptsCounter.channel < self.maxAttempts.channel ){
                callback ("retry", checkTstamp, self.relaunchChannelLoop );
            }else {
                
                if (self.errCounter.channel < 3 ){
                    self.errCounter.channel++;
                }else {
                    self.errCounter.channel = 0;
                    self.status.channel = "Err-Unknown";
                    self.status.tstamp = Math.floor(new Date().getTime()/1000);
                }
                
                callback ("next", checkTstamp, function (){return;} );
                self.relaunchChannelLoop();
            }

            return;
        }

        self.log ( 'id: ' + self.data.id + ' : Channel Response : HEX: ' + data.toString('hex') + ' | UTF8: ' + data.toString('utf8') );
        self.errCounter.channel = 0;

        //Translate Result to self.status.channel
        self.translateChannelQuerry( data );
        //console.log ( new Date() + ' - ' + self.name + ', screen: '+ self.data.id + " : Result check channel status: " + self.status.channel );


        if ( self.attemptsCounter.channel < self.maxAttempts.channel ){
            callback ("retry", checkTstamp, self.relaunchChannelLoop);
        }else {
            callback ("next", checkTstamp, function (){return;}  );
            self.relaunchChannelLoop();
        }


        // Special Callback End
        self.endChannelQuerry();
    }

    this.relaunchChannelLoop = function (){
        clearTimeout ( self.timers.channel );
        if (!self.stopping && self.timers.channel ) {
            self.timers.channel = setTimeout ( self.checkChannelStatus , self.intervals.channel );
        }
        return;
    }
    
/********************************* SCHEDULLE *********************************/
    this.checkSchedule = function (){
        //console.log ( new Date() + ' - ' + self.name + ', screen: '+ self.data.id + " : Start check schedule // Internal_ID: " + self.data.internal_id );
        self.log ( 'id: ' + self.data.id + ' : Schedule Querry' );
        var scheduledPower = self.getScheduledPower ( self.config.schedule , self.config.delay)

        if ( self.status.power == -1 && !self.forceSchedulle ){
            self.checkScheduleCallback( null, "Screen Disabled: Power -1");
        }else{
            if ( self.status.power != scheduledPower ){

                //console.log ( new Date() + ' - ' + self.name + ', screen: '+ self.data.id + " : Result check schedule: Change needed");

                if ( scheduledPower ){
                    self.turnOn( self.checkScheduleCallback );
                }else{
                    self.turnOff( self.checkScheduleCallback );
                }
            }else{
                self.checkScheduleCallback( null, "OK");
            }
        }
    }
    //Private Callback
    this.checkScheduleCallback = function (err, data, checkTstamp, callback){
        self.attemptsCounter.schedule++;
        if (err){
            //console.log ( new Date() + ' - ' + self.name + ', screen: '+ self.data.id + " : ERROR check schedule status: " + err );
            self.log ( 'id: ' + self.data.id + ' : Schedule Error : ' + err );
            self.errorHandling ( err );

            if ( self.attemptsCounter.schedule < self.maxAttempts.schedule ){
            callback ("retry", checkTstamp, self.relaunchScheduleLoop );
            }else {
                callback ("next", checkTstamp, function (){return;}  );
                self.relaunchScheduleLoop();
            }

            self.relaunchScheduleLoop();
            return;
        }
        
        self.log ( 'id: ' + self.data.id + ' : Schedule Response : HEX: ' + data.toString('hex') + ' | UTF8: ' + data.toString('utf8') );

        self.errCounter.schedule = 0;
        //console.log ( new Date() + ' - ' + self.name + ', screen: '+ self.data.id + " : Result check schedule: " + data );
        
        if ( data == "OK" ){
            self.relaunchScheduleLoop();
            return;
        }
        if ( self.attemptsCounter.schedule < self.maxAttempts.schedule ){
            callback ("retry", checkTstamp, self.relaunchScheduleLoop );
        }else {
            callback ("next", checkTstamp, function (){return;}  );
            self.relaunchScheduleLoop();
        }

        
    }

    this.relaunchScheduleLoop = function (){
        clearTimeout ( self.timers.schedule );
        if (!self.stopping && self.timers.schedule ) {
            self.timers.schedule = setTimeout ( self.checkSchedule , self.intervals.schedule );
        }
        return;
    }
    
    
    
/*********************************** MISC ***********************************/
    this.generateOnQuerry  = function (){ return ""; };
    this.translateOnQuerry = function ( data ){ return; }; //depreciated
    this.generateOffQuerry  = function (){ return ""; };
    this.translateOffQuerry = function ( data ){ return; }; //depreciated


    this.turnOn = function ( callback ) {
        //console.log ( new Date() + ' - ' + self.name + ', screen: '+ self.data.id + " : Start turn on" );
        self.log ( 'id: ' + self.data.id + ' : Turn On Querry' );
        var command = self.generateOnQuerry();
        self.driver.send ( command , self.portValues, callback );
    }
    
    this.turnOff = function ( callback ) {
        //console.log ( new Date() + ' - ' + self.name + ', screen: '+ self.data.id + " : Start turn off");
        self.log ( 'id: ' + self.data.id + ' : Turn Off Querry' );
        var command = self.generateOffQuerry();
        self.driver.send ( command , self.portValues, callback );
    }
    

    this.generateBroadcastOnQuerry = function (){ return ""; };
    this.generateBroadcastOffQuerry  = function (){ return ""; };

    /******************************** FREE COMMAND PARSING ********************************/
    this.freeCommandParse = function ( cmd, callback ){
        self.log ( 'Screen commands: IN driver')

        self.freeCmd = cmd
        self.freeCommandCallback = callback;
        self.freeCmd.output = "Accepted: Loaded"
        self.log ( 'Screen commands: IN driver 2')
        if (cmd.input.toLowerCase().includes("reboot") ){
            self.log ( 'Screen commands: reboot')
            self.rebootParse ();
        }else{
            self.log ( 'Screen commands: sendFreeCommand')
            self.sendFreeCommand ();
        }
    }


    /******************************** FREE COMMAND: REBOOT ********************************/
    this.rebootParse = function (){

        if ( self.freeCmd.input.includes ( " ") ){
            var cmdInputArray = self.freeCmd.input.split ("");
            self.data.remote_id = cmdInputArray[1]
            self.singularReboot ();

        }else{
            self.allReboot ();
        }
    }

    //Prototype on screen basis
    this.singularRebootAvailable = false;
    this.singularReboot = function (){
        if ( self.singularRebootAvailable ){
            self.freeCmd.output = "Accepted: Reboot one in development"
            
            var commandOff = self.generateOffQuerry();
            var commandOn = self.generateOnQuerry();

            self.driver.sendPriorityArray ( [commandOff,commandOn] , [self.portValues, self.portValues] , [ self.singularRebootOffCallback, self.singularRebootOnCallback ] );

        }else{
            self.freeCmd.output = "Rejected: Reboot one not available"
            self.freeCommandCallback( self.freeCmd );
        }
    }

    this.singularRebootOffCallback = function ( err, data, checkTstamp, callback ){
        self.log ( 'Screen commands: singularRebootOffCallback')
        if (err) {
            self.freeCmd.output = err;
        }
        else {
            self.freeCmd.output = data;
        }
        //callback ("retry", checkTstamp, self.relaunchScheduleLoop );
        callback ("step", checkTstamp, function (){return;}  );
        //TODO timer for step, never more than driver timeout

    }

    this.singularRebootOnCallback = function ( err, data, checkTstamp, callback ){
        self.log ( 'Screen commands: singularRebootOnCallback')
        if (err) {
            self.freeCmd.output = err;
        }
        else {
            self.freeCmd.output = data;
        }
        //callback ("retry", checkTstamp, self.relaunchScheduleLoop );
        callback ("next", checkTstamp, function (){return;}  );

        self.freeCommandCallback( self.freeCmd );
    }
    //Prototype on screen basis
    this.allRebootAvailable = false;
    this.allReboot = function (){
        if ( self.allRebootAvailable ){
            self.freeCmd.output = "Rejected: Reboot all in development";
            self.freeCommandCallback( self.freeCmd );
        }else{
            self.freeCmd.output = "Rejected: Reboot all not available";
            self.freeCommandCallback( self.freeCmd );
        }
    }

    this.allRebootCallback = function (){

    }


    /******************************** FREE COMMAND: CUSTOM ********************************/
    this.generateFreeQuerry  = function ( command ){ return command; };
    this.translateFreeQuerry = function ( data ){ return; };
    this.endFreeQuerry      = function (){ return; };

    this.sendFreeCommand = function () {
        //console.log ( new Date() + ' - ' + self.name + ', screen: '+ self.data.id + " : Start send free command");
        var command = self.generateFreeQuerry( self.freeCmd.input );
        self.log ( 'Screen commands: sent to port: ' + command )
        self.driver.sendPriority ( command , self.portValues, self.sendFreeCommandCallback );
    }
    //Private Callback
    this.sendFreeCommandCallback = function (err, data, checkTstamp, callback){
        self.log ( 'Screen commands: sendFreeCommandCallback')
        if (err) { self.freeCmd.output = err; self.log ( 'Screen commands: sendFreeCommandCallback ERROR: ' + self.freeCmd.output)/*console.log ( new Date() + ' - ' + self.name + ', screen: '+ self.data.id + " : ERROR send free command: " + err ); */}
        else { self.freeCmd.output = data; self.log ( 'Screen commands: sendFreeCommandCallback GOOD: ' + self.freeCmd.output)/*console.log ( new Date() + ' - ' + self.name + ', screen: '+ self.data.id + " : Result send free command: " + data ); */}
        self.translateFreeQuerry( data );
        self.endFreeQuerry( );
        self.freeCommandCallback ( self.freeCmd )
    }
    
    
    /*********************************** ERROR FUNCTIONS ***********************************/
    this.errorHandling = function ( err ) {
    	//console.log(err);
        if      ( err.message.includes ( "Forced Time Out") ) { self.status.lastCMD = "Forced Time Out"; }
        else if ( err.message.includes ( "Socket Timeout") ) { self.status.lastCMD = "Socket Timeout"; }
        else if ( err.message.includes ( "Cannot lock port") || err.message.includes ("Access den") ) { self.status.lastCMD = "Temporarily unavailable"; }
        else if ( err.message.includes ( "No such file or directory") || err.message.includes ("File not found") ) { self.status.lastCMD = "Port does not exist"; }
        else { self.status.lastCMD = err.message; }
        self.notifyError(self.ERROR['SCREEN_SERVICE']+0, self.name + ": driver error : " + err );
    }
    
    /*********************************** SCHEDULLE FUNCTIONS ***********************************/

    this.getBinSchedule = function ( schedule) {
        var bufferSchedule = Buffer.from(schedule, "hex");
        var binSchedule = []
        for ( var i = 0; i < bufferSchedule.length; i++ ){
            binSchedule = binSchedule.concat (self.byte2Boolean (bufferSchedule[i]))
        }
        return binSchedule;
    },
    
    this.byte2Boolean = function ( byte ) {
        var ret = [];
        for (var i = 0; i < 8; i++) {
            ret[8 - 1 - i] = (1 << i & byte) != 0;
        }
        return ret;
    },
    
    this.getScheduledPower = function ( schedule , delay){
    	var date = self.getDate();
    	if (delay) date = new Date (date.getTime()-delay*1000*60) //change date in funtion of delay
        position = self.getPosition( date );
        return schedule[position]
    },
    
    this.getPosition = function( date ){
        var position = date.getDay();
        if(position == 0) position = 7; //correct day shift ( Sunday = 0 )
        position = ( position - 1 ) * 24; //get position of day
        position = position + date.getHours(); // add hour position
        return position
    };

    this.checkExceptions = function ( screenExceptions, exceptions ){
        // console.log ( new Date() + ' - ' + self.name + ', screen: '+ self.data.id + " : Start selectException // Internal_ID: " + self.data.internal_id );
        // console.log ( new Date() + ' - ' + self.name + ', screen: '+ self.data.id + " : selectException screenExceptions: " + screenExceptions );
        // console.log ( new Date() + ' - ' + self.name + ', screen: '+ self.data.id + " : selectException exceptions: " + exceptions );
        // console.log ( exceptions );
        for (var i = 0; i < screenExceptions.length; i++ ){
            for ( var j = 0; j < exceptions.length; j++ ){
                // console.log ( 'compare' )
                // console.log ( screenExceptions[i] )
                // console.log ( exceptions[j].id )
                if ( screenExceptions[i] == exceptions[j].id ){
                    self.selectException ( exceptions[j] );
                }
            }
        }
    }

    this.selectException = function ( exception ){
        // console.log ( new Date() + ' - ' + self.name + ', screen: '+ self.data.id + " : Start selectException // Internal_ID: " + self.data.internal_id );
        // console.log ( exception );
        if ( exception.today ){
            if ( self.exceptions.today.type < exception.type ){
                self.exceptions.today = exception
            }
            else if ( self.exceptions.today.type = exception.type ){
                if ( self.exceptions.today.id < exception.id ){
                    self.exceptions.today = exception
                }
            }
        }else{
            if ( self.exceptions.yesterday.type < exception.type ){
                self.exceptions.yesterday = exception
            }
            else if ( self.exceptions.yesterday.type = exception.type ){
                if ( self.exceptions.yesterday.id < exception.id ){
                    self.exceptions.yesterday = exception
                }
            }
        }
    }

    this.applyExceptions = function (){
        // console.log ( new Date() + ' - ' + self.name + ', screen: '+ self.data.id + " : Start applyExceptions // Internal_ID: " + self.data.internal_id );
        var dow = self.getDayOfWeek() - 1;
        // console.log ( new Date() + ' - ' + self.name + ', screen: '+ self.data.id + " :     applyExceptions: dow" + dow );
        // console.log ( new Date() + ' - ' + self.name + ', screen: '+ self.data.id + " :     applyExceptions: yt" + self.exceptions.yesterday.type );
        // console.log ( new Date() + ' - ' + self.name + ', screen: '+ self.data.id + " :     applyExceptions: tt" + self.exceptions.today.type );
        switch ( self.exceptions.yesterday.type ){
            case -1:
                break;
            case 0:
                self.exceptions.yesterday.binSchedule = self.getBinSchedule ( self.exceptions.yesterday.schedule )
                break;
            case 1:
                var day = parseInt ( self.exceptions.yesterday.schedule )
                self.exceptions.yesterday.binSchedule = self.config.schedule.slice ( day, day + 48);
                break;
            case 2:
                self.exceptions.yesterday.binSchedule = self.getBinSchedule ( self.exceptions.yesterday.schedule )
                break;
            default :
                break;
        }


        switch ( self.exceptions.today.type ){
            case -1:
                break;
            case 0:
                self.exceptions.today.binSchedule = self.getBinSchedule ( self.exceptions.today.schedule )
                break;
            case 1:
                var day = parseInt ( self.exceptions.today.schedule )
                self.exceptions.today.binSchedule = self.config.schedule.slice ( day, day + 48);
                break;
            case 2:
                self.exceptions.today.binSchedule = self.getBinSchedule ( self.exceptions.today.schedule )
                break;
            default :
                break;
        }

        // console.log ( new Date() + ' - ' + self.name + ', screen: '+ self.data.id + " :     applyExceptions: " + self.config.schedule );
        // console.log ( new Date() + ' - ' + self.name + ', screen: '+ self.data.id + " :     applyExceptions: " + self.exceptions.yesterday.binSchedule );
        // console.log ( new Date() + ' - ' + self.name + ', screen: '+ self.data.id + " :     applyExceptions: " + self.exceptions.today.binSchedule );

        if ( self.exceptions.yesterday.type != -1 ){
            console.log ( new Date() + ' - ' + self.name + ', screen: '+ self.data.id + " :     applyExceptions: self.exceptions.yesterday " );
            for ( var i = 0; i < self.exceptions.splitTime; i++ ){
                self.config.schedule [dow*24 + i ] = self.exceptions.yesterday.binSchedule [24+i]
            } 
        }
        if ( self.exceptions.today.type != -1 ){
            console.log ( new Date() + ' - ' + self.name + ', screen: '+ self.data.id + " :     applyExceptions: self.exceptions.today " );
            for ( var i = self.exceptions.splitTime; i < 24; i++ ){
                self.config.schedule [dow*24 + i ] = self.exceptions.today.binSchedule [i]
            }
        }
        // console.log ( new Date() + ' - ' + self.name + ', screen: '+ self.data.id + " : End applyExceptions: " + self.config.schedule );

    }
    
    /*********************************** CHECKSUM FUNCTIONS ***********************************/

    this.getXorChecksum = function ( data ) {
        var checksum = Buffer.from ( '00' , 'hex');
        for (i = 0; i < data.length; i++)
        {
            checksum[0] ^= data[i];
        }
        return checksum
    }
    
    this.getSumChecksumMod256= function ( data ) {
        var checksum = Buffer.from ( '00' , 'hex');
        for (i = 0; i < data.length; i++)
        {
            checksum[0] += data[i];
        }
        return checksum
    }
    
    /*********************************** DATE FUNCTION ***********************************/
    
    this.getDate = function(utc,timestamp){
        if(typeof(timestamp) === "undefined"){ timestamp = -1; }
        if(typeof(utc) === "undefined"){ utc = false; }
        var systemDate = new Date();
        if(self.server_time_activated){
            var timezone_offset = 0;
            if(!utc){
                timezone_offset = self.server_time_timezone_offset*-1;
            }
            if(timestamp >= 0){
                timestamp = (timestamp+timezone_offset);
            }else{
                var system_timestamp = systemDate.getTime();
                if(self.platform == "SOC"){
                     var time_api = document.getElementById('timePlugin');
                     time_api.Open('Time', '1.000', 'Time');
                     system_timestamp = parseInt(time_api.Execute('GetEpochTime'));
                     time_api.Close();
                     time_api = null;
                     system_timestamp = system_timestamp * 1000;
                }
                timestamp = (system_timestamp+(self.server_time_local_offset*-1)+(timezone_offset));
            }
            systemDate = new Date(timestamp);
        }else{
             if(self.platform == "SOC"){
                 var time_api = document.getElementById('timePlugin');
                 time_api.Open('Time', '1.000', 'Time');
                 timestamp = parseInt(time_api.Execute('GetEpochTime'));
                 time_api.Close();
                 timestamp = timestamp * 1000;
                 var d = new Date(timestamp);
                 var offset = d.getTimezoneOffset();
                 offset = offset * 60;
                 offset = offset * 1000;
                 timestamp += offset;
                 time_api = null;
            }
            if(timestamp > 0){
                systemDate = new Date(timestamp);
            }
        }
        return systemDate;
    };
	
}

BasicScreenController.prototype = new BasicService();