
/* Compatible models:
 *      - 
 *      - 
 *      - 
 *      - 
 *      - 
 *      - 
 *      - 
 */

function Screen() {
}

Screen.prototype = new BasicScreenController();
Screen.prototype.constructor = Screen();


// Reference to "this" that won't get clobbered by some other "this"
//Screen.prototype.self = this;
Screen.prototype.name = "PANASONIC_RS232";

/* 
 * Timers use
 * if (timer = * ) it will load if (timer = 0) it won't load
 * Once init is called, timeouts references are stored here
 */
Screen.prototype.timers = {
    power : 1,
    channel : 0,
    schedule : 1
}

Screen.prototype.maxAttempts = {
    power : 1,
    channel : 0,
    schedule : 1
};

/******************************** PORT ********************************/    
//Conf
Screen.prototype.portValues = {
        name : '',
        config : {
                baudRate : 9600,
                dataBits : 8,
                stopBits : 1
        },
        parser : {
            type : 'byteDelimiter' ,
            delimiter : [120]
        }   
}

//SPECIAL
Screen.prototype.command_init = Buffer.from ( 'AD94;RAD:' , 'ascii');


//PROTOTYPING
/******************************** INIT PROTOTYPING ********************************/
Screen.prototype.formatRemoteId = function ( id ) {
    return Buffer.from ( ( "000" + id.toString()).substr(-3) , 'ascii');
};
Screen.prototype.loadDriver = function ( platform ) {
    if  ( typeof RS232_driverController !== "function" ){
        eval('eval')(fs.readFileSync('./app/screenDrivers/RS232.js')+'');
    }

    return new RS232_driverController ();
};

Screen.prototype.loadPortValues = function () {} ;


/******************************** STATUS PROTOTYPING ********************************/

Screen.prototype.generatePowerQuerry = function (){
    var command = Buffer.from ( ';QPW' , 'ascii');
    return Buffer.concat([this.STX, this.command_init, this.data.formated_remote_id, command, this.ETX ]);
}

Screen.prototype.translatePowerQuerry = function ( data ){
    this.status.lastCMD = data.toString('ascii');
    data = data.toString();
    if (data.includes('QPW:1') ){
        this.status.power = 1;
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.power = this.maxAttempts.power;
    }else if (data.includes('QPW:0') ){
        this.status.power = 0;
        this.status.tstamp = Math.floor(new Date().getTime()/1000);
        this.attemptsCounter.power = this.maxAttempts.power;
    }else{
        if ( !(this.attemptsCounter.power < this.maxAttempts.power) ){
            this.status.power = -1;
            this.status.tstamp = Math.floor(new Date().getTime()/1000);
        }
    }
    return;
};


Screen.prototype.endPowerQuerry = function (){
    return;
};


/******************************** CHANNEL PROTOTYPING ********************************/

Screen.prototype.generateChannelQuerry = function (){
    var command = Buffer.from ( ';QMI' , 'ascii');
    return Buffer.concat([this.STX, this.command_init, this.data.formated_remote_id, command, this.ETX ]);
};


Screen.prototype.translateChannelQuerry = function ( data ){
    this.status.lastCMD = data.toString('ascii');
    this.status.channel = data.toString('ascii');;   
    this.status.tstamp = Math.floor(new Date().getTime()/1000);
    this.attemptsCounter.channel = this.maxAttempts.channel;

    return;
};

Screen.prototype.endChannelQuerry = function (){};
    
/******************************** SCHEDULE PROTOTYPING ********************************/
Screen.prototype.generateScheduleQuerry  = function (){ return ""; };
Screen.prototype.translateScheduleQuerry = function ( data ){ return; };
Screen.prototype.endScheduleQuerry       = function (){
        this.attemptsCounter.schedule = this.maxAttempts.schedulereturn;
        return;
    };

/******************************** MISC PROTOTYPING ********************************/
Screen.prototype.generateOnQuerry  = function (){
    var command = Buffer.from ( ';PON' , 'ascii');
    return Buffer.concat([this.STX, this.command_init, this.data.formated_remote_id, command, this.ETX ]);
};
Screen.prototype.translateOnQuerry = function ( data ){ return; };


Screen.prototype.generateOffQuerry  = function (){
    var command = Buffer.from ( ';POF' , 'ascii');
    return Buffer.concat([this.STX, this.command_init, this.data.formated_remote_id, command, this.ETX ]);
};
Screen.prototype.translateOffQuerry = function ( data ){ return; };


/******************************** FREE COMMAND: REBOOT PROTOTYPING ********************************/
Screen.prototype.singularRebootAvailable = true;
//Screen.prototype.allRebootAvailable = true;


/******************************** FREE COMMAND: CUSTOM PROTOTYPING ********************************/
Screen.prototype.generateFreeQuerry  = function ( commandRecived ){
    var command = Buffer.from ( ';' + commandRecived , 'ascii');
    return Buffer.concat([this.STX, this.command_init, this.data.formated_remote_id, command, this.ETX ]);
};
Screen.prototype.translateFreeQuerry = function ( data ){ return; };
Screen.prototype.endFreeQuerry      = function (){ return; };



